/*
 * daytime.c
 */

__asm("	text\n	dc.b	'$Id: daytime.c,v 1.2 1998/10/17 08:28:37 sharl Exp $'\n	even\n");

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include "author.h"
#include "socksub.h"

char *__progname;

static void
usage()
{
	fprintf(stderr, "Usage: %s [-v] host\n", __progname);
	fprintf(stderr, "  -v: print version\n");
}

int
main(int argc, char *argv[])
{
	int sock;
	char *host, buf[256];
	char *p;
	int c;

	__progname = argv[0];
	while ((c = getopt(argc, argv, "v")) != EOF) {
		switch (c) {
			case 'v':
				fprintf(stderr, "%s (" PACKAGE " " VERSION ") (C)1998 " AUTHOR "\n", __progname);
				return EXIT_SUCCESS;
			default:
				usage();
				return EXIT_FAILURE;
		}
	}

	if (argc - 1 != optind){
		usage();
		return EXIT_FAILURE;
	}
	host = argv[optind];

	sock = connect_sub(host, "daytime", "tcp", 13);
	if (sock < 0)
		return EXIT_FAILURE;
	read(sock, buf, sizeof(buf));
	for (p = buf; *p; p++) {
		if (*p == '\n') {
			*p = '\0';
			break;
		}
	}
	puts(buf);
	close(sock);
	return EXIT_SUCCESS;
}
