/*
 * socksub.c
 */

__asm("	text\n	dc.b	'$Id: socksub.c,v 1.1 1998/10/17 07:33:48 sharl Exp $'\n	even\n");

#include <stdio.h>
#include <string.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <arpa/nameser.h>
#include <netdb.h>
#include <sys/socket.h>
#include "socksub.h"

int
connect_sub(char *host, char *service, char *proto, short port)
{
	struct sockaddr_in saddr;
	struct hostent *shost;
	struct servent *serv, sserv;
	int sock;

	if ((serv = getservbyname(service, proto)) == NULL) {
		serv = &sserv;
		serv->s_port = port;
	}
	memset(&saddr, 0, sizeof(saddr));
	if (isipaddr(host)) {
		saddr.sin_addr.s_addr = inet_addr(host);
		if ((shost = gethostbyaddr((char *)&saddr.sin_addr,
				sizeof(saddr.sin_addr), AF_INET)) == NULL) {
			fprintf(stderr, "gethostbyaddr() failed.\n");
			return -1;
		}
		host = shost->h_name;
	} else {
		shost = gethostbyname(host);
		if (shost) {
			memcpy(&saddr.sin_addr, shost->h_addr, shost->h_length);
		} else {
			fprintf(stderr, "%s: host name lookup failed.\n", host);
			return -1;
		}
	}

	saddr.sin_family = AF_INET;
	saddr.sin_port = htons(serv->s_port);

	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		fprintf(stderr, "can't create socket.\n");
		return 1;
	}
	if (connect(sock, (struct sockaddr *)&saddr, sizeof(struct sockaddr)) < 0) {
		fprintf(stderr, "%s: unable to connect: %s\n", host, sockerr(sock));
		return -1;
	}

	return sock;
}
